﻿* Encoding: UTF-8.
*Frequency weighting
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_WEIGR*/vers5*******************************************************************.
define !KO_weigr(vars= !charend('/') /wname= !charend('/') /wvar= !charend('/') /splvar= !charend('/') /restr= !charend('/') /iter= !charend('/')
                /total= !charend('/') /report= !charend('/') /hist= !charend('/') /mode= !charend('/') /method= !charend('/') /props= !cmdend)
!let !ok= 1
exec.
echo '**** WEIGHTING GROUPS ****'.
!if (!head(!props)='/') !then !let !props2= !tail(!props) !else !let !props2= !props !ifend
!if (!substr(!props2,!length(!props2))<>'/') !then !let !trail= '/' !ifend
!if (!restr=!null) !then !let !rf= 0
!else
 !if (!index('0123456789',!substr(!restr,1,1))>0) !then !let !rf= 1 !else !let !rf= 0 !ifend
!ifend
!if ((!tail(!vars)=!null !or !method='CART') !and (!restr='NEGRES' !or !rf)) !then !let !ok= 0
-echo ''.
-echo '>ERROR. RESTR= NEGRES или число не возможно при единственной переменной VARS'.
-echo '>или при method=CART.'.
!else !if (!vars=!null !or !props=!null !or !props='/') !then !let !ok= 0
-echo ''.
-echo '>ERROR. Не задано VARS или PROPS.'.
!else !if (!tail(!vars)<>!null !and !method<>'CART' !and !iter=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. В VARS несколько переменных и METHOD не CART, но не задано ITER.'.
!else !let !prps= !conc(!props2,!trail)
 !do !w !in (!vars)
  !if (!prps=!null) !then !let !err= '>ERROR. PROPS не соответствует числу переменных VARS.' !break !ifend
  !let !prps= !tail(!substr(!prps,!index(!prps,'/')))
 !doend
 !if (!prps<>!null) !then !let !err= '>ERROR. PROPS не соответствует числу переменных VARS.' !ifend
 !if (!err<>!null) !then !let !ok= 0
- echo ''.
- echo !quote(!err).
 !ifend
!ifend !ifend !ifend
!if (!ok) !then
 !if (!wname=!null) !then !let !wnam= 'weight_$'
- echo ''.
- echo '>WARNING. WNAME не задано. Выходящая весовая переменная будет называться WEIGHT_$.'.
- echo '>Если такая числовая переменная уже существует в массиве,'.
- echo '>она будет перезаписана.'.
 !else !let !wnam= !wname
 !ifend
 !if (!upcase(!wnam)=!upcase(!wvar)) !then
- echo ''.
- echo '>WARNING. WVAR и заданное имя выходящей весовой переменной (WNAME) совпадают.'.
- echo '>Это значит, что исходные веса WVAR будут:'.
- echo '>1) не только учтены, но и обновлены - для наблюдений,'.
- echo '>участвующих во взвешивании;'.
- echo '>2) останутся исходными - для наблюдений, не участвующих во взвешивании.'.
 !ifend
 !if (!tail(!vars)=!null) !then
  !if (!method<>!null) !then
-  echo ''.
-  echo '>WARNING. METHOD игнорируется, если переменных VARS одна.'.
  !ifend
-  echo ''.
-  echo 'Будет взвешивание по одной переменной.'.
 !else !if (!method='CART') !then
- echo ''.
- echo 'Будет одномерное взвешивание по нескольким переменным (декартово).'.
 !else
- echo ''.
- echo 'Будет многомерное взвешивание (по нескольким переменным, ободочное)'.
- echo !quote(!conc('в ITER=',!iter,' итераций.')).
 !ifend !ifend
 !if (!splvar<>!null) !then
- set errors none.
- sort cases by !splvar.
- set errors list.
- split file by !splvar.
 !else
- split file off.
 !ifend
 !if (!wvar=!null) !then
- comp !wnam= 1.
 !else
  !if (!upcase(!wvar)=!upcase(!wname)) !then
-  comp wv$$$$$2= value(!wvar).
  !ifend
- recode !wvar (miss lo thru 0=0) (else=copy) into !wnam.
- comp fo$$$$$= 1.
- weight off.
- set results none errors none.
- aggreg /outfile= * mode= add over= yes /fo$$$$$= first(fo$$$$$).
- if sysmis(fo$$$$$) !wnam= $sysmis.
- exec.
 !ifend
-set results none errors none.      
-comp wv$$$$$= value(!wnam).
-exec.
-miss val !wnam ().
-weight by !wnam.
 !let !elist= !null !let !spec1= !null !let !spec2= !null !let !vrs= !vars !let !var= !head(!vrs)
 !let !count= ' ' !let !i= !length(!count) !let !vlist= !null !let !hold= 0 !let !adjust= 0
 !if (!mode='LIST') !then !let !list= 1 !else !let !list= 0 !let !todo= 1 !ifend
 !let !alleq= 0 !let !allveq= 0
 !do !w !in (!conc(!props2,!trail))
  !if (!w<>'/') !then
   !if (!head(!unquote(!w))='ALLEQ') !then !let !alleq= 1
   !else !if (!head(!unquote(!w))='ALLVEQ') !then !let !allveq= 1
   !else !if (!head(!unquote(!w))<>!null !and !w<>'[' !and !w<>']') !then
    !if (!list) !then
     !if (!unquote(!w)<>!w) !then !let !codes= !unquote(!w) !let !todo= 0
     !else !let !todo= 1
      !if (!head(!codes)='-') !then !let !code= !conc('-',!head(!tail(!codes))) !let !codes= !tail(!tail(!codes))
      !else !let !code= !head(!codes) !let !codes= !tail(!codes)
      !ifend
      !let !p= !w
     !ifend
    !else !let !w2= !unquote(!w)
     !if (!head(!w2)='-') !then !let !code= !conc('-',!head(!tail(!w2))) !let !p= !head(!tail(!tail(!w2)))
     !else !let !code= !head(!w2) !let !p= !head(!tail(!w2))
     !ifend
    !ifend
    !if (!todo) !then
     !if (!code=!null !or !p=!null) !then !let !ok= 0
-     set results list errors list.
-     exec.
-     echo ''.
-     echo '>ERROR. В PROPS число кодов групп и число целевых размеров для них,'.
-     echo '>видимо, различаются. Проверьте аккуратность задания PROPS.'.
-     echo '>Также, не перепутайте MODE= PAIR и LIST.'.
-     echo '>!KO_WEIGR выполнен неверно.'.
      !break
     !ifend
     !if (!code='SYSMIS' !or !code='MISSING') !then !let !newcode= '-999'
     !else !if (!code='ELSE') !then !let !newcode= 'copy' !let !spec1= !conc(!spec1,' (sysmis=-999)')
     !else !if (!code='ELSEV') !then !let !newcode= 'copy' !let !spec1= !conc(!spec1,' (miss=sysmis)')
     !else !let !newcode= !code
     !ifend !ifend !ifend
     !if (!p='HOLD') !then !let !p= '-999' !let !hold= 1 !ifend
     !if (!p='ADJUST') !then !let !p= '-9999' !let !adjust= 1 !ifend
     !if (!code='ELSEV') !then !let !spec1= !conc(!spec1,' (else=',!newcode,')')
     !else !let !spec1= !conc(!spec1,' (',!code,'=',!newcode,')')
     !ifend
     !if (!code='ELSE') !then !let !newcode= 'else'
     !else !if (!code='ELSEV') !then !let !newcode= 'sysmis=copy) (else'
     !ifend !ifend
     !let !spec2= !conc(!spec2,' (',!newcode,'=',!p,')')
    !ifend
   !ifend !ifend !ifend
  !else !let !vvar= !conc('v$$$$$',!i) !let !pvar= !conc('p$$$$$',!i) !let !tvar= !conc('t$$$$$',!i)
   !let !xvar= !conc('x$$$$$',!i) !let !yvar= !conc('y$$$$$',!i) !let !zvar= !conc('z$$$$$',!i)
   !let !vlist= !conc(!vlist,',',!vvar)
   !if (!alleq !or !allveq) !then
-   recode !var !if (!alleq) !then (sysmis=-999) !else (miss=sysmis) !ifend (else=copy) into !vvar.
-   weight off.
-   rank !vvar /rank into !pvar /ties= condense /print= no.
-   aggreg /outfile= * mode= add over= yes /!pvar= max(!pvar).
-   weight by !wnam.
-   comp !pvar= 1/!pvar.
-   rank !vvar /n into !tvar /print= no.
    !let !alleq= 0 !let !allveq= 0
   !else
-   recode !var !spec1 into !vvar.
-   recode !vvar !spec2 into !pvar.
-   rank !vvar /n into !tvar /print= no.
    !if (!hold !or !adjust) !then
-    rank !tvar by !vvar /n into !xvar /print= no.
-    do if !pvar=-9999.
-     comp a$$$$$= 1.
-    else.
-     comp a$$$$$= 0.
-    end if.
-    if any(!pvar,-999,-9999) !pvar= !xvar/!tvar.
     !if (!adjust) !then
-     temp.
-     comp !wnam= !wnam*!pvar/!xvar.
-     rank !pvar by a$$$$$ /n into !yvar /print= no.
-     do if a$$$$$.
-      comp !zvar= !yvar.
-      comp !yvar= $sysmis.
-     end if.
-     rmv !yvar !zvar= smean(!yvar !zvar).
-     if a$$$$$ !pvar= !pvar*(1-!yvar)/!zvar.
      !let !elist= !conc(!elist,' ',!yvar,' ',!zvar)
     !ifend
     !let !elist= !conc(!elist,' ',!xvar,' a$$$$$')
    !ifend
   !ifend
   !let !elist= !conc(!elist,' ',!pvar,' ',!tvar)
   !if (!upcase(!var)=!upcase(!total)) !then !let !itot= !i !ifend
   !let !spec1= !null !let !spec2= !null !let !vrs= !tail(!vrs) !let !var= !head(!vrs) !let !count= !conc(!count,' ')
   !let !i= !length(!count) !let !hold= 0 !let !adjust= 0
  !ifend
 !doend
 !let !nvars= !length(!substr(!count,2))
 !if (!ok) !then
  !if (!tail(!vars)=!null !or !method='CART') !then !let !itr= 1 !else !let !itr= !iter !ifend
   !if (!method='CART') !then
-   comp p$$$$$1= p$$$$$1 !do !i= 2 !to !nvars *!conc('p$$$$$',!i) !doend.
    !let !nvars2= !nvars !let !nvars= 1
    !if (!restr<>!null) !then
-    do if $casenum=1.
      !do !i= 2 !to !nvars2
-      comp !conc('#rv1_',!i)= unif(1).
-      comp !conc('#rv2_',!i)= unif(10).
      !doend
-    end if.
-    comp v$$$$$1= v$$$$$1 !do !i= 2 !to !nvars2 +(!conc('v$$$$$',!i)+!conc('#rv1_',!i))*!conc('#rv2_',!i) !doend.
    !ifend
   !ifend
- do if nmiss(!tail(!vlist))=0.
-  comp lw$$$$$= 1.
- else.
-  recode !tail(!vlist) !wnam (else=sysmis).
- end if.
  !if (!total='SELECTED' !or !total=!null) !then
-  rank lw$$$$$ /n into tot$$$$$ /print= no.
  !else !if (!itot<>!null) !then
-  comp tot$$$$$= !conc('t$$$$$',!itot).
  !else
-   comp tot$$$$$= !total.
  !ifend !ifend
- comp nz$$$$$= 1.
  !do !i= 1 !to !nvars
-  comp nz$$$$$= nz$$$$$*(!conc('p$$$$$',!i)>0).
-  comp !conc('p$$$$$',!i)= !conc('p$$$$$',!i)*tot$$$$$.
  !doend
  !if (!rf) !then !let !elist= !conc(!elist,' cc$$$$$')
-  weight off.
-  rank lw$$$$$ by v$$$$$1 to !conc('v$$$$$',!nvars) /n into cc$$$$$ /print= no.
-  weight by !wnam.
  !ifend
  !if (!restr<>'NONE' !and !restr<>!null !and !not !rf) !then !let !elist= !conc(!elist,' alw$$$$$ cw$$$$$')
   !do !i= 1 !to !nvars
-   rank lw$$$$$ by !conc('v$$$$$',!i) /n into !conc('g$$$$$',!i) /print= no.
   !doend
   !if (!restr='NEGRES') !then !let !elist= !conc(!elist,' c$$$$$ tlw$$$$$')
-   rank lw$$$$$ by v$$$$$1 to !conc('v$$$$$',!nvars) /n into c$$$$$ /print= no.
-   rank lw$$$$$ /n into tlw$$$$$ /print= no.
-   comp alw$$$$$= 1.
-   do rep g= g$$$$$1 to !conc('g$$$$$',!nvars).
-    comp alw$$$$$= alw$$$$$*g/tlw$$$$$.
-   end rep.
-   comp alw$$$$$= (c$$$$$-alw$$$$$*tlw$$$$$)>=0.
   !else
-   comp alw$$$$$= !restr.
   !ifend
-  if not nz$$$$$ alw$$$$$= 1.
-  comp cw$$$$$= !wnam*(1-alw$$$$$).
-  comp !wnam= !wnam*alw$$$$$.
-  exec.
-  del vari tot$$$$$.
-  rank lw$$$$$ /n into tot$$$$$ /print= no.
   !do !i= 1 !to !nvars
-   rank lw$$$$$ by !conc('v$$$$$',!i) /n into !conc('h$$$$$',!i) /print= no.
-   comp !conc('p$$$$$',!i)= !conc('p$$$$$',!i)-(!conc('g$$$$$',!i)-!conc('h$$$$$',!i)).
   !doend
-  exec.
-  del vari g$$$$$1 to !conc('g$$$$$',!nvars) h$$$$$1 to !conc('h$$$$$',!nvars).
  !ifend
- weight off.
  !do !it= 1 !to !itr
   !do !i= 1 !to !nvars
    !if (!rf) !then
-    aggreg /outfile= * mode= add /break= !splvar v$$$$$1 to !conc('v$$$$$',!nvars) /c$$$$$= sum(!wnam).
-    if c$$$$$<!restr and c$$$$$>0 and nz$$$$$ !wnam= !wnam+(!restr+.1-c$$$$$)/cc$$$$$.
-    exec.
-    del vari c$$$$$.
    !ifend
-   aggreg /outfile= * mode= add /break= !splvar !conc('v$$$$$',!i)
      !if (!method='CART') !then
       !do !i2= 2 !to !nvars2 !conc('v$$$$$',!i2) !doend
      !ifend /!conc('g$$$$$',!i)= sum(!wnam).
-   recode !conc('g$$$$$',!i) (0=sysmis).
-   comp !wnam= !wnam*!conc('p$$$$$',!i)/!conc('g$$$$$',!i).
   !doend
-  exec.
-  del vari g$$$$$1 to !conc('g$$$$$',!nvars).
  !doend
- weight by !wnam.
  !if (!restr<>'NONE' !and !restr<>!null !and !not !rf) !then
-  comp !wnam= !wnam+cw$$$$$.
  !ifend
- if sysmis(lw$$$$$) !wnam= $sysmis.
- set results list.
  !if (!report<>'NO') !then
-  echo ''.
-  echo 'GROUP SIZES AFTER WEIGHTING:'.
-  frequ !vars.
-  var lev !wnam (sca).
   !if (!hist='YES') !then
-   temp.
-   weight off.
-   split file off.
-   GRAPH /HISTOGRAM= !wnam /TITLE= 'Weights Histogram' !if (!splvar<>!null) !then +' (ignoring split by subsamples)' !ifend.
   !ifend
-  temp.
-  split file off.
-  weight off.
-  matrix.
-  get w /vari= wv$$$$$ !wnam /miss= omit.
-  print /title 'INPUT AND OUTPUT WEIGHTS SUMMARY' !if (!splvar<>!null) !then +' (ignoring split by subsamples)' !ifend.
-  print /title 'Only cases undergone weighting procedure are the base of the summary.' /space= 0.
-  print nrow(w) /title 'Number of cases with non-sysmis weights (the weighted sample):'.
-  print csum(w>0) /title 'Number of cases with positive weights:' /clab= 'Initial' 'Final'.
-  print csum(w=0) /title 'Number of cases with zero weights:' /clab= 'Initial' 'Final'.
-  comp sum= csum(w).
-  print {cmin(w);cmax(w);sum/nrow(w)} /title 'Weights statistics:' /clab= 'Initial' 'Final' /rlab= 'Min' 'Max' 'Mean' /format= f8.4.
   !if (!wvar<>!null) !then
-   print /title 'Note: In initial weight variable (WVAR subcommand), any value except'.
-   print /title '      valid positive was treated as zero weight' /space= 0.
   !ifend
-  print sum /title 'Total sum of weights (sample size):' /clab= 'Initial' 'Final' /format= f12.4.
-  print (csum(w(:,1)&*w(:,2))**2/(sum(:,1)*csum(w(:,1)&*w(:,2)&**2))) /title 'Weighting Efficiency proportion:' /format= f8.4.
-  end matrix.
  !else
-  exec.
  !ifend
  !if (!wvar<>!null !and !upcase(!wvar)=!upcase(!wname)) !then
-  if sysmis(!wnam) !wnam= wv$$$$$2.
-  exec.
-  del var wv$$$$$2.
  !ifend
- set errors list.
- del vari !vlist !elist lw$$$$$ tot$$$$$ nz$$$$$ wv$$$$$ !if (!wvar<>!null) !then fo$$$$$ !ifend.
 !ifend
!else
-echo '>!KO_WEIGR не выполнен.'.
!ifend
!enddefine.
